#!/bin/bash

# uninstall logic for Desktop Backup Manager 6.13.4.0
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/Desktop Backup Manager/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for Desktop Backup Manager"
    touch "/Applications/Desktop Backup Manager/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
if [ -e "/Applications/Desktop Backup Manager/aua/bin" ]; then
    echo "Shutdown AutoUpdateAgent for Desktop Backup Manager"
    sh "/Applications/Desktop Backup Manager/aua/bin/shutdown.sh"
    echo "Wait 5 seconds before AutoUpdateAgent exits"
    sleep 5
fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/Desktop Backup Manager/bin/taskkill" "/Applications/Desktop Backup Manager/BackupManager.app"
sh "/Applications/Desktop Backup Manager/bin/taskkill" "/Applications/Desktop Backup Manager/bin/BackupManager.app"
sh "/Applications/Desktop Backup Manager/bin/taskkill" "/Applications/Desktop Backup Manager/jvm/bin/java"
sh "/Applications/Desktop Backup Manager/bin/taskkill" "/Applications/Desktop Backup Manager/aua/jvm/bin/java"

###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/DesktopBackupManager" ]; then
    echo "Remove Scheduler for Desktop Backup Manager from service"
    rm -rf "/Library/StartupItems/DesktopBackupManager"
fi

# Remove AutoUpdateAgent
if [ -e "/Library/StartupItems/DesktopBackupManager-AutoUpdate" ]; then
    echo "Remove AutoUpdateAgent for Desktop Backup Manager from service"
    rm -rf "/Library/StartupItems/DesktopBackupManager-AutoUpdate"
fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/DesktopBackupManager" ]; then
        echo "Remove Desktop Link DesktopBackupManager from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/DesktopBackupManager"
        echo "Removed Desktop Backup Manager Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/Desktop Backup Manager" ]; then
        echo "Remove Desktop Link Desktop Backup Manager from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/Desktop Backup Manager"
        echo "Removed Desktop Backup Manager Desktop Link"
    fi
done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove Desktop Backup Manager
cd /
if [ -e "/Applications/Desktop Backup Manager" ]; then
    echo "Remove Desktop Backup Manager from Your Mac OS X"
    rm -rf "/Applications/Desktop Backup Manager"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/acb.pkg" ]; then
    echo "Remove Mac OS X Receipt for acb.pkg (Path: /Library/Receipts/acb.pkg)"
    rm -rf "/Library/Receipts/acb.pkg"
fi
